> For the complete documentation index, see [llms.txt](https://docs.easy.gg/scripting/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.easy.gg/scripting/bedwars-scripting/services/inputservice.md).

# InputService

Example usage:

```lua
-- Start a 10 second tornado event whenever the host presses the X key
InputService.registerInputBegan(KeyCode.X, function (player)
    if (player == MatchService.getHost()) then
        DisasterService.startDisaster(DisasterType.TORNADO, 10)
    end
end)

-- Start a 10 second meteors event whenever the host stops pressing the Z key
InputService.registerInputEnded(KeyCode.Z, function (player)
    if (player == MatchService.getHost()) then
        DisasterService.startDisaster(DisasterType.METEORS, 10)
    end
end)
```

### Functions

#### registerInputBegan(keyCode: [KeyCode](broken://pages/rBD6V5rOrL4nMksHQ9tL), function: (player: [Player](/scripting/bedwars-scripting/objects/player.md)) => nil)

Begins tracking the beginning of user input of the key code from all players. The callback function will run every time the key code is pressed.

#### registerInputEnded(keyCode: [KeyCode](broken://pages/rBD6V5rOrL4nMksHQ9tL), function: (player: [Player](/scripting/bedwars-scripting/objects/player.md)) => nil)

Begins tracking the end of user input of the key code from all players. The callback function will run every time the key code is pressed.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.easy.gg/scripting/bedwars-scripting/services/inputservice.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
